diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 92c7ab6e3..dd4bbef8f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -8,6 +8,8 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFire;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean overrideRender;
@@ -21,17 +23,17 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockMetadata(x, y, z));
         if(renderBlocks.overrideBlockTexture != null)
         {
             tex = renderBlocks.overrideBlockTexture;
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z)));
+        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z)));
         }else {
-        	brightness = renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double uMin = tex.getIconUMin();
@@ -39,7 +41,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
         double vMin = tex.getIconVMin();
         double vMax = tex.getIconVMax();
         final float yOffset = 1.4F;
-        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y - 1, z))
+        if(overrideRender || worldSource.isBlockNormalCube(x, y - 1, z) || BlockLogicFire.canBurn(worldSource, x, y - 1, z))
         {
             double d8 = (double)x + 0.5D + 0.2D;
             double d9 = ((double)x + 0.5D) - 0.2D;
@@ -114,7 +116,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
                 uMax = uMin;
                 uMin = d10;
             }
-            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x - 1, y, z))
+            if(BlockLogicFire.canBurn(worldSource, x - 1, y, z))
             {
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
@@ -125,7 +127,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
             }
-            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x + 1, y, z))
+            if(BlockLogicFire.canBurn(worldSource, x + 1, y, z))
             {
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
@@ -136,7 +138,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
             }
-            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y, z - 1))
+            if(BlockLogicFire.canBurn(worldSource, x, y, z - 1))
             {
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
@@ -147,7 +149,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
             }
-            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y, z + 1))
+            if(BlockLogicFire.canBurn(worldSource, x, y, z + 1))
             {
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
@@ -158,7 +160,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
             }
-            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y + 1, z))
+            if(BlockLogicFire.canBurn(worldSource, x, y + 1, z))
             {
                 double d11 = (double)x + 0.5D + 0.5D;
                 double d13 = ((double)x + 0.5D) - 0.5D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
index 2c600d299..9c7e400f1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFlowerStackable<T extends BlockLogicFlowerStackable> extends BlockModelCrossedSquares<T> {
     private final IconCoordinate[] ICONS;
@@ -19,7 +20,7 @@ public class BlockModelFlowerStackable<T extends BlockLogicFlowerStackable> exte
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         final int stackCount = T.getStackCount(data);
         if (stackCount > T.MAX_STACK_COUNT) {
             return ICONS[0];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 783fe0b99..0ff1ed113 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelFluid(Block<T> block) {
@@ -19,21 +20,21 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
 
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
 
-        boolean renderTop = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y + 1, z, 1);
-        boolean flag1 = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y - 1, z, 0);
+        boolean renderTop = shouldSideBeRendered(worldSource, bounds, x, y + 1, z, Side.TOP);
+        boolean flag1 = shouldSideBeRendered(worldSource, bounds, x, y - 1, z, Side.BOTTOM);
         boolean[] aflag = new boolean[4];
-        aflag[0] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z - 1, 2);
-        aflag[1] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z + 1, 3);
-        aflag[2] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x - 1, y, z, 4);
-        aflag[3] = shouldSideBeRendered(renderBlocks.blockAccess, bounds, x + 1, y, z, 5);
+        aflag[0] = shouldSideBeRendered(worldSource, bounds, x, y, z - 1, Side.NORTH);
+        aflag[1] = shouldSideBeRendered(worldSource, bounds, x, y, z + 1, Side.SOUTH);
+        aflag[2] = shouldSideBeRendered(worldSource, bounds, x - 1, y, z, Side.WEST);
+        aflag[3] = shouldSideBeRendered(worldSource, bounds, x + 1, y, z, Side.EAST);
         if(!renderTop && !flag1 && !aflag[0] && !aflag[1] && !aflag[2] && !aflag[3])
         {
             return false;
@@ -47,16 +48,16 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
 
         final float yOff = 0.001f;
         Material material = block.getMaterial();
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        float f7 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
-        float f8 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
-        float f9 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
-        float f10 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
+        int meta = worldSource.getBlockMetadata(x, y, z);
+        float f7 = BlockLogicFluid.getFluidHeight(worldSource, x, y, z, material);
+        float f8 = BlockLogicFluid.getFluidHeight(worldSource, x, y, z + 1, material);
+        float f9 = BlockLogicFluid.getFluidHeight(worldSource, x + 1, y, z + 1, material);
+        float f10 = BlockLogicFluid.getFluidHeight(worldSource, x + 1, y, z, material);
         if(renderBlocks.renderAllFaces || renderTop)
         {
             didRender = true;
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
-            float rotation = (float) BlockLogicFluid.getSlopeAngle(renderBlocks.blockAccess, x, y, z, material);
+            float rotation = (float) BlockLogicFluid.getSlopeAngle(worldSource, x, y, z, material);
             if(rotation > -999F)
             {
                 texture = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
@@ -65,12 +66,12 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
             }
             float blockBrightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
-            	int light = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-            	int lightUp = block.getLightmapCoord(renderBlocks.blockAccess, x, y + 1, z);
+            	int light = block.getLightmapCoord(worldSource, x, y, z);
+            	int lightUp = block.getLightmapCoord(worldSource, x, y + 1, z);
             	
             	tessellator.setLightmapCoord(LightmapHelper.max(light, lightUp));
             }else {
-            	blockBrightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            	blockBrightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
             }
             if (texture.namespaceId.toString().contains("_flowing")){
                 double centerU = texture.getSubIconU(0.5);
@@ -101,9 +102,9 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
         {
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
-            	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y - 1, z));
+            	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y - 1, z));
             }else {
-            	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
+            	brightness = renderBlocks.getBlockBrightness(worldSource, x, y - 1, z);
             }
             tessellator.setColorOpaque_F(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
 
@@ -192,9 +193,9 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
             double d8 = texture.getSubIconV(0.5F + vOff);
 			float brightness = 1.0f;
 			if(LightmapHelper.isLightmapEnabled()) {
-				tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, xB, yB, zB));
+				tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, xB, yB, zB));
 			}else {
-				brightness = getBlockBrightness(renderBlocks.blockAccess, xB, yB, zB);
+				brightness = renderBlocks.getBlockBrightness(worldSource, xB, yB, zB);
 			}
 			if(side < 2) {
 				brightness *= sideNorthSouth;
@@ -216,7 +217,7 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
         Material material = blockAccess.getBlockMaterial(x, y, z);
         if(material == block.getMaterial())
@@ -227,7 +228,7 @@ public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T>
         {
             return true;
         }
-        if(side == Side.TOP.getId())
+        if(side == Side.TOP)
         {
             return true;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index 411126ea4..0db8d6a2a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFullyRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -15,8 +17,8 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        final int meta = worldSource.getBlockMetadata(x, y, z);
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(meta);
 
         switch (dir) {
@@ -53,20 +55,20 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
                 renderBlocks.uvRotateBottom = 2;
                 break;
         }
-        final boolean result = renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
-        resetRenderBlocks();
+        final boolean result = renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.resetRenderBlocks();
 
         return result;
     }
 
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, 1, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, 1, brightness, alpha, lightmapCoordinate);
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(data);
         if (side == dir.getSide()) {
             return blockTextures.get(Side.TOP);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
index a1f862167..592b70f97 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
@@ -8,6 +8,7 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFurnace<T extends BlockLogic>
     extends BlockModelHorizontalRotation<T> {
@@ -17,13 +18,13 @@ public class BlockModelFurnace<T extends BlockLogic>
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
         int data = blockAccess.getBlockMetadata(x, y, z);
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data, 5) + side.getId()];
         if (index >= Sides.orientationLookUpHorizontal.length) return blockTextures.get(Side.BOTTOM);
         if (index == Side.NORTH.getId()) {
             IconCoordinate originalFront = blockTextures.get(Side.NORTH);
-            Container container = (Container) blockAccess.getBlockEntity(x, y, z);
+            Container container = (Container) blockAccess.getTileEntity(x, y, z);
             if (container != null) {
                 boolean hasOutput = container.getItem(2) != null;
                 if (hasOutput) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
new file mode 100644
index 000000000..f6c098ddb
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
@@ -0,0 +1,102 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T>{
+    private final StaticBlockModel staticModel;
+
+    public BlockModelGeneric(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block);
+        this.staticModel = staticModel;
+    }
+
+    public BlockModelGeneric(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block);
+        this.staticModel = staticModel.asModel();
+    }
+
+    @Override
+    public boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        return staticModel.renderAttached(this,
+            tessellator,
+            worldSource, x,
+            y,
+            z,
+            0, 0, 0, false, null);
+    }
+
+    @Override
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        return staticModel.renderAttached(this,
+            tessellator,
+            worldSource, x,
+            y,
+            z,
+            0, 0, 0, true, null);
+    }
+
+    @Override
+    public boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        throw new UnsupportedOperationException();
+    }
+
+    @Override
+    public boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, IconCoordinate textureIndex) {
+        return staticModel.renderAttached(this,
+            tessellator,
+            worldSource, x,
+            y,
+            z,
+            0, 0, 0, true, textureIndex);
+    }
+
+    @Override
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        staticModel.renderStandalone(this,
+            tessellator, 0, 0, 0,
+            metadata,
+            BlockColorDispatcher.getInstance().getDispatch(block),
+            brightness, alpha);
+    }
+
+    @Override
+    public boolean shouldItemRender3d() {
+        return true;
+    }
+
+    @Override
+    public @NotNull DisplayPos getItemDisplayPos(@NotNull String id) {
+        return staticModel.getItemDisplayPos(id);
+    }
+
+    @Override
+    public int renderLayer() {
+        return staticModel.renderLayer();
+    }
+
+    @Override
+    public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta) {
+        return staticModel.getParticle(side);
+    }
+
+    @Override
+    public @Nullable IconCoordinate getOverlayTexture(int meta) {
+        return staticModel.getOverlay();
+    }
+
+    @Override
+    public int particleColorIndex(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta) {
+        return staticModel.particleColorIndex(side);
+    }
+}
